# Ipopt::GenAugSystemSolver Class Reference

Solver for the augmented system using GenKKTSolverInterfaces. More...

`#include <IpGenAugSystemSolver.hpp>`

Inheritance diagram for Ipopt::GenAugSystemSolver:
[legend]

List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
virtual ESymSolverStatus | MultiSolve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, std::vector< SmartPtr< const Vector > > &rhs_xV, std::vector< SmartPtr< const Vector > > &rhs_sV, std::vector< SmartPtr< const Vector > > &rhs_cV, std::vector< SmartPtr< const Vector > > &rhs_dV, std::vector< SmartPtr< Vector > > &sol_xV, std::vector< SmartPtr< Vector > > &sol_sV, std::vector< SmartPtr< Vector > > &sol_cV, std::vector< SmartPtr< Vector > > &sol_dV, bool check_NegEVals, Index numberOfNegEVals)
| Set up the augmented system and solve it for a set of given right hand side - implementation for GenTMatrices and SymTMatrices.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
Constructors/Destructors
| GenAugSystemSolver (GenKKTSolverInterface &SolverInterface)
| Constructor using only a linear solver object.
virtual | ~GenAugSystemSolver ()
| Default destructor.
## Private Member Functions
bool | AugmentedSystemChanged (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix &J_c, const Vector *D_c, double delta_c, const Matrix &J_d, const Vector *D_d, double delta_d)
| Check the internal tags and decide if the passed variables are different from what is in the augmented_system_.
void | UpdateTags (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix &J_c, const Vector *D_c, double delta_c, const Matrix &J_d, const Vector *D_d, double delta_d)
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| GenAugSystemSolver ()
| Default constructor.
| GenAugSystemSolver (const GenAugSystemSolver &)
| Copy Constructor.
void | operator= (const GenAugSystemSolver &)
| Overloaded Equals Operator.
## Private Attributes
SmartPtr< GenKKTSolverInterface > | solver_interface_
| The linear solver object that is to be used to solve the linear systems.
Tags and values to track in order to decide whether the
matrix has to be updated compared to the most recent call of the Set method.
TaggedObject::Tag | w_tag_
| Tag for W matrix.
double | w_factor_
| Most recent value of W_factor.
TaggedObject::Tag | d_x_tag_
| Tag for D_x vector, representing the diagonal matrix D_x.
double | delta_x_
| Most recent value of delta_x from Set method.
TaggedObject::Tag | d_s_tag_
| Tag for D_s vector, representing the diagonal matrix D_s.
double | delta_s_
| Most recent value of delta_s from Set method.
TaggedObject::Tag | j_c_tag_
| Tag for J_c matrix.
TaggedObject::Tag | d_c_tag_
| Tag for D_c vector, representing the diagonal matrix D_c.
double | delta_c_
| Most recent value of delta_c from Set method.
TaggedObject::Tag | j_d_tag_
| Tag for J_d matrix.
TaggedObject::Tag | d_d_tag_
| Tag for D_d vector, representing the diagonal matrix D_d.
double | delta_d_
| Most recent value of delta_d from Set method.
Space for storing the diagonal matrices. If the matrix
hasn't changed, we can use it from the last call.
Number * | dx_vals_copy_
Number * | ds_vals_copy_
Number * | dc_vals_copy_
Number * | dd_vals_copy_
Algorithmic parameters
bool | warm_start_same_structure_
| Flag indicating whether the TNLP with identical structure has already been solved before.

## Detailed Description

Solver for the augmented system using GenKKTSolverInterfaces.

This takes any Vector values out and provides Number*'s, but Matrices are provided as given from the NLP.

Definition at line 22 of file IpGenAugSystemSolver.hpp.

## Constructor & Destructor Documentation

Ipopt::GenAugSystemSolver::GenAugSystemSolver | ( | GenKKTSolverInterface & | SolverInterface | ) |

Constructor using only a linear solver object.

virtual Ipopt::GenAugSystemSolver::~GenAugSystemSolver | ( |  | ) | `[virtual]`

Default destructor.

Ipopt::GenAugSystemSolver::GenAugSystemSolver | ( |  | ) | `[private]`

Default constructor.

Ipopt::GenAugSystemSolver::GenAugSystemSolver | ( | const GenAugSystemSolver & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::GenAugSystemSolver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::AugSystemSolver.

virtual ESymSolverStatus Ipopt::GenAugSystemSolver::MultiSolve | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix * | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix * | J_d,
|  | const Vector * | D_d,
|  | double | delta_d,
|  | std::vector< SmartPtr< const Vector > > & | rhs_xV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_sV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_cV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_dV,
|  | std::vector< SmartPtr< Vector > > & | sol_xV,
|  | std::vector< SmartPtr< Vector > > & | sol_sV,
|  | std::vector< SmartPtr< Vector > > & | sol_cV,
|  | std::vector< SmartPtr< Vector > > & | sol_dV,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Set up the augmented system and solve it for a set of given right hand side - implementation for GenTMatrices and SymTMatrices.

Reimplemented from Ipopt::AugSystemSolver.

virtual Index Ipopt::GenAugSystemSolver::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last solve.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implements Ipopt::AugSystemSolver.

virtual bool Ipopt::GenAugSystemSolver::ProvidesInertia | ( |  | ) | const`[virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::AugSystemSolver.

virtual bool Ipopt::GenAugSystemSolver::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Ask underlying linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implements Ipopt::AugSystemSolver.

void Ipopt::GenAugSystemSolver::operator= | ( | const GenAugSystemSolver & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::AugSystemSolver.

bool Ipopt::GenAugSystemSolver::AugmentedSystemChanged | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix & | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix & | J_d,
|  | const Vector * | D_d,
|  | double | delta_d |
| ) |  |  | `[private]`

Check the internal tags and decide if the passed variables are different from what is in the augmented_system_.

void Ipopt::GenAugSystemSolver::UpdateTags | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix & | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix & | J_d,
|  | const Vector * | D_d,
|  | double | delta_d |
| ) |  |  | `[private]`

## Member Data Documentation

SmartPtr<GenKKTSolverInterface> Ipopt::GenAugSystemSolver::solver_interface_`[private]`

The linear solver object that is to be used to solve the linear systems.

Definition at line 136 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::w_tag_`[private]`

Tag for W matrix.

If W has been given to Set as NULL, then this tag is set to 0

Definition at line 146 of file IpGenAugSystemSolver.hpp.

double Ipopt::GenAugSystemSolver::w_factor_`[private]`

Most recent value of W_factor.

Definition at line 148 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::d_x_tag_`[private]`

Tag for D_x vector, representing the diagonal matrix D_x.

If D_x has been given to Set as NULL, then this tag is set to 0

Definition at line 152 of file IpGenAugSystemSolver.hpp.

double Ipopt::GenAugSystemSolver::delta_x_`[private]`

Most recent value of delta_x from Set method.

Definition at line 154 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::d_s_tag_`[private]`

Tag for D_s vector, representing the diagonal matrix D_s.

If D_s has been given to Set as NULL, then this tag is set to 0

Definition at line 158 of file IpGenAugSystemSolver.hpp.

double Ipopt::GenAugSystemSolver::delta_s_`[private]`

Most recent value of delta_s from Set method.

Definition at line 160 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::j_c_tag_`[private]`

Tag for J_c matrix.

If J_c has been given to Set as NULL, then this tag is set to 0

Definition at line 164 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::d_c_tag_`[private]`

Tag for D_c vector, representing the diagonal matrix D_c.

If D_c has been given to Set as NULL, then this tag is set to 0

Definition at line 168 of file IpGenAugSystemSolver.hpp.

double Ipopt::GenAugSystemSolver::delta_c_`[private]`

Most recent value of delta_c from Set method.

Definition at line 170 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::j_d_tag_`[private]`

Tag for J_d matrix.

If J_d has been given to Set as NULL, then this tag is set to 0

Definition at line 174 of file IpGenAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::GenAugSystemSolver::d_d_tag_`[private]`

Tag for D_d vector, representing the diagonal matrix D_d.

If D_d has been given to Set as NULL, then this tag is set to 0

Definition at line 178 of file IpGenAugSystemSolver.hpp.

double Ipopt::GenAugSystemSolver::delta_d_`[private]`

Most recent value of delta_d from Set method.

Definition at line 180 of file IpGenAugSystemSolver.hpp.

Number* Ipopt::GenAugSystemSolver::dx_vals_copy_`[private]`

Definition at line 186 of file IpGenAugSystemSolver.hpp.

Number* Ipopt::GenAugSystemSolver::ds_vals_copy_`[private]`

Definition at line 187 of file IpGenAugSystemSolver.hpp.

Number* Ipopt::GenAugSystemSolver::dc_vals_copy_`[private]`

Definition at line 188 of file IpGenAugSystemSolver.hpp.

Number* Ipopt::GenAugSystemSolver::dd_vals_copy_`[private]`

Definition at line 189 of file IpGenAugSystemSolver.hpp.

bool Ipopt::GenAugSystemSolver::warm_start_same_structure_`[private]`

Flag indicating whether the TNLP with identical structure has already been solved before.

Definition at line 196 of file IpGenAugSystemSolver.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/IpGenAugSystemSolver.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines